#include "CrownGlass_MeshGlass.inc"
#include "CrownGlass_MeshRing.inc"
#include "woods.inc"

#declare CrownGlass = union {
   object { CrownGlass_Glass }
   object { CrownGlass_Ring }
   rotate x*90
}


#ifndef(T_CrownGlassWindow_Wood)
   #declare T_CrownGlassWindow_Wood= texture { T_Wood18 }
#end



#macro CrownGlass_Window (WindowHeight, WindowWidth, PieceDiameter, FrameWidth, WindowType)

// window will be in box { <0,0,-1>,<WindowWidth,WindowHeight,1> }

// WindowHeight: height of the window
// WindowWidth: width of the window
// PieceDiameter: diamater of the discs (1 unit = 1 cm, common values range from  to 12)
// FrameWidth: width of the wooden frame
// WindowType: 1 for orthogonal grid, 2 for "diagonal" grid

      #declare CrownGlass_ScaleZ=0.5/0.155697;

      #declare CrownGlass_Radius=PieceDiameter/2;
      #if(WindowType=1)
         #declare CrownGlass_OffsetY=PieceDiameter;
      #end
      #if (WindowType=2)
         #declare CrownGlass_OffsetY=CrownGlass_Radius*sqrt(3);
      #end
      
      union {
         difference {
            box { <0,0,-1>,<FrameWidth*0.9,WindowHeight,1>  }
            box { <-2*FrameWidth,-2*FrameWidth,-2>,<2*FrameWidth,0,2> rotate z*45 }
            box { <-2*FrameWidth,0,-2>,<2*FrameWidth,2*FrameWidth,2> rotate -z*45 translate y*WindowHeight }
            texture { T_CrownGlassWindow_Wood rotate x*87 scale <10,1,1> }
         }
   
         difference {
            box { <0,0,-1>,<FrameWidth*0.9,WindowHeight,1>  }
            box { <-2*FrameWidth,-2*FrameWidth,-2>,<2*FrameWidth,0,2> rotate z*45 }
            box { <-2*FrameWidth,0,-2>,<2*FrameWidth,2*FrameWidth,2> rotate -z*45 translate y*WindowHeight }
            texture { T_CrownGlassWindow_Wood rotate x*87 scale <10,1,1> }
            rotate z*180
            translate <WindowWidth,WindowHeight,0>
         }

         difference {
            box { <0,0,-1>,<FrameWidth*0.9,WindowWidth,1>  }
            box { <-2*FrameWidth,-2*FrameWidth,-2>,<2*FrameWidth,0,2> rotate z*45 }
            box { <-2*FrameWidth,0,-2>,<2*FrameWidth,2*FrameWidth,2> rotate -z*45 translate y*WindowWidth }
            texture { T_CrownGlassWindow_Wood rotate x*87 scale <10,1,1> }
            rotate z*90
            translate x*WindowWidth
         }

         difference {
            box { <0,0,-1>,<FrameWidth*0.9,WindowWidth,1> }
            box { <-2*FrameWidth,-2*FrameWidth,-2>,<2*FrameWidth,0,2> rotate z*45 }
            box { <-2*FrameWidth,0,-2>,<2*FrameWidth,2*FrameWidth,2> rotate -z*45 translate y*WindowWidth }
            texture { T_CrownGlassWindow_Wood rotate x*87 scale <10,1,1> }
            rotate -z*90
            translate y*WindowHeight
         }

         union {
            box { <FrameWidth*0.8,FrameWidth*0.8,-0.5>,<FrameWidth,WindowHeight-FrameWidth*0.8,0.5> }
            box { <WindowWidth-FrameWidth,FrameWidth*0.8,-0.5>,<WindowWidth-FrameWidth*0.8,WindowHeight-FrameWidth*0.8,0.5> }
            box { <FrameWidth,FrameWidth*0.8,-0.5>,<WindowWidth-FrameWidth*0.8,FrameWidth,0.5> }
            box { <FrameWidth,WindowHeight-FrameWidth,-0.5>,<WindowWidth-FrameWidth*0.8,WindowHeight-FrameWidth*0.8,0.5> }
            texture { CrownGlass_RingTexture }
         }



         difference {
            box { <FrameWidth*0.9,FrameWidth*0.9,-0.024>,<WindowWidth-FrameWidth*0.9,WindowHeight-FrameWidth*0.9,0.024>
               scale <1,1,CrownGlass_ScaleZ>
            }
   
            #declare CrownGlass_AktPosY=FrameWidth+CrownGlass_Radius;
            #declare CrownGlass_LR=1;
            #while (CrownGlass_AktPosY<WindowHeight-FrameWidth+CrownGlass_Radius)
               #declare CrownGlass_AktPosX=FrameWidth+CrownGlass_Radius;
               #if (WindowType=2)
                  #declare CrownGlass_AktPosX=FrameWidth+CrownGlass_Radius/2+CrownGlass_LR*CrownGlass_Radius/2;
               #end
               #while (CrownGlass_AktPosX<=WindowWidth-FrameWidth+CrownGlass_Radius)
                  cylinder { <0,0,-0.024*2*CrownGlass_ScaleZ>,<0,0,0.024*2*CrownGlass_ScaleZ>,CrownGlass_Radius*1.00001
                     translate <CrownGlass_AktPosX,CrownGlass_AktPosY,0>
                  }
                  #declare CrownGlass_AktPosX=CrownGlass_AktPosX+PieceDiameter;
               #end
               #declare CrownGlass_AktPosY=CrownGlass_AktPosY+CrownGlass_OffsetY;
               #declare CrownGlass_LR=-CrownGlass_LR;
            #end
   
            texture { CrownGlass_GlassTexture }
            interior { I_CrownGlass }
         }

         difference {
            union {
               #declare CrownGlass_AktPosY=FrameWidth+CrownGlass_Radius;
               #declare CrownGlass_LR=1;
               #while (CrownGlass_AktPosY<WindowHeight-FrameWidth+CrownGlass_Radius)
                  #declare CrownGlass_AktPosX=FrameWidth+CrownGlass_Radius;
                  #if (WindowType=2)
                     #declare CrownGlass_AktPosX=FrameWidth+CrownGlass_Radius/2+CrownGlass_LR*CrownGlass_Radius/2;
                  #end
                  #while (CrownGlass_AktPosX<=WindowWidth-FrameWidth+CrownGlass_Radius)
                     object { CrownGlass scale <CrownGlass_Radius,CrownGlass_Radius,CrownGlass_ScaleZ>
                        translate <CrownGlass_AktPosX,CrownGlass_AktPosY,0>
                     }
                     #declare CrownGlass_AktPosX=CrownGlass_AktPosX+PieceDiameter;
                  #end
                  #declare CrownGlass_AktPosY=CrownGlass_AktPosY+CrownGlass_OffsetY;
                  #declare CrownGlass_LR=-CrownGlass_LR;
               #end
   
            }
            box { <-PieceDiameter,-PieceDiameter,-1>,<WindowWidth+PieceDiameter,FrameWidth,1> }
            box { <-PieceDiameter,WindowHeight-FrameWidth,-1>,<WindowWidth+PieceDiameter,WindowHeight+PieceDiameter,1> }
            box { <-PieceDiameter,-PieceDiameter,-1>,<FrameWidth,WindowHeight+PieceDiameter,1> }
            box { <WindowWidth-FrameWidth,-PieceDiameter,-1>,<WindowWidth+PieceDiameter,WindowHeight+PieceDiameter,1> }
         }
      }
#end

#macro CrownGlass_Window_RoundTop (WindowHeight, WindowWidth, PieceDiameter, FrameWidth, WindowType)
// WindowHeight: height of the window
// WindowWidth: width of the window
// PieceDiameter: diamater of the discs (1 unit = 1 cm, common values range from  to 12)
// FrameWidth: width of the wooden frame
// WindowType: 1 for orthogonal grid, 2 for "diagonal" grid

   #if(WindowWidth/2 <= WindowHeight)
      #local _H=WindowHeight-WindowWidth/2;
      
      #declare CrownGlass_ScaleZ=0.5/0.155697;

      #declare CrownGlass_Radius=PieceDiameter/2;
      #if(WindowType=1)
         #declare CrownGlass_OffsetY=PieceDiameter;
      #end
      #if (WindowType=2)
         #declare CrownGlass_OffsetY=CrownGlass_Radius*sqrt(3);
      #end
      
      union {
         difference {
            box { <0,0,-1>,<FrameWidth*0.9,_H,1>  }
            box { <-2*FrameWidth,-2*FrameWidth,-2>,<2*FrameWidth,0,2> rotate z*45 }
            //box { <-2*FrameWidth,0,-2>,<2*FrameWidth,2*FrameWidth,2> rotate -z*45 translate y*_H }
            texture { T_CrownGlassWindow_Wood rotate x*87 scale <10,1,1> }
         }
   
         difference {
            box { <0,0,-1>,<FrameWidth*0.9,_H,1>  }
            //box { <-2*FrameWidth,-2*FrameWidth,-2>,<2*FrameWidth,0,2> rotate z*45 }
            box { <-2*FrameWidth,0,-2>,<2*FrameWidth,2*FrameWidth,2> rotate -z*45 translate y*_H }
            texture { T_CrownGlassWindow_Wood rotate x*87 scale <10,1,1> }
            rotate z*180
            translate <WindowWidth,_H,0>
         }

         difference {
            box { <0,0,-1>,<FrameWidth*0.9,WindowWidth,1>  }
            box { <-2*FrameWidth,-2*FrameWidth,-2>,<2*FrameWidth,0,2> rotate z*45 }
            box { <-2*FrameWidth,0,-2>,<2*FrameWidth,2*FrameWidth,2> rotate -z*45 translate y*WindowWidth }
            texture { T_CrownGlassWindow_Wood rotate x*87 scale <10,1,1> }
            rotate z*90
            translate x*WindowWidth
         }
         
         difference {
            cylinder { <WindowWidth/2,_H,-1>,<WindowWidth/2,_H,1>,WindowWidth/2 }
            cylinder { <WindowWidth/2,_H,-1.1>,<WindowWidth/2,_H,1.1>,WindowWidth/2-FrameWidth*0.9 }
            box { <-WindowWidth,_H-WindowWidth,-1.1>,<WindowWidth,_H,1.1> }
            texture { T_CrownGlassWindow_Wood rotate x*87 scale <10,1,1> rotate z*77}
         }
    
         /*difference {
            box { <0,0,-1>,<FrameWidth*0.9,WindowWidth,1> texture { T_CrownGlassWindow_Wood rotate x*87 scale <10,1,1> } }
            box { <-2*FrameWidth,-2*FrameWidth,-2>,<2*FrameWidth,0,2> rotate z*45 }
            box { <-2*FrameWidth,0,-2>,<2*FrameWidth,2*FrameWidth,2> rotate -z*45 translate y*WindowWidth }
   
            rotate -z*90
            translate y*_H
         }*/

         union {
            box { <FrameWidth*0.8,FrameWidth*0.8,-0.5>,<FrameWidth,_H,0.5> }
            box { <WindowWidth-FrameWidth,FrameWidth*0.8,-0.5>,<WindowWidth-FrameWidth*0.8,_H,0.5> }
            box { <FrameWidth,FrameWidth*0.8,-0.5>,<WindowWidth-FrameWidth*0.8,FrameWidth,0.5> }
            difference {
               cylinder { <WindowWidth/2,_H,-0.5>,<WindowWidth/2,_H,0.5>,WindowWidth/2-FrameWidth*0.8 }
               cylinder { <WindowWidth/2,_H,-1>,<WindowWidth/2,_H,1>,WindowWidth/2-FrameWidth }
               box { <0,_H-WindowWidth,-1,>,<WindowWidth,_H,1> }
            }
            
           // box { <FrameWidth,_H-FrameWidth,-0.5>,<WindowWidth-FrameWidth*0.8,_H-FrameWidth*0.8,0.5> }
            texture { CrownGlass_RingTexture }
         }
    

         intersection {
            union {
               cylinder { <WindowWidth/2,_H,-1>,<WindowWidth/2,_H,1>,WindowWidth/2-FrameWidth*0.8 }
               box { <FrameWidth*0.8,FrameWidth,-1>,<WindowWidth-FrameWidth*0.8,_H,1> }
               pigment { color Clear }
            }
            union {
               difference {
                  box { <FrameWidth*0.9,FrameWidth*0.9,-0.024>,<WindowWidth-FrameWidth*0.9,WindowHeight-FrameWidth*0.9,0.024>
                     scale <1,1,CrownGlass_ScaleZ>
                  }
   
                  #declare CrownGlass_AktPosY=FrameWidth+CrownGlass_Radius;
                  #declare CrownGlass_LR=1;
                  #while (CrownGlass_AktPosY<WindowHeight-FrameWidth+CrownGlass_Radius)
                     #declare CrownGlass_AktPosX=FrameWidth+CrownGlass_Radius;
                     #if (WindowType=2)
                        #declare CrownGlass_AktPosX=FrameWidth+CrownGlass_Radius/2+CrownGlass_LR*CrownGlass_Radius/2;
                     #end
                     #while (CrownGlass_AktPosX<=WindowWidth-FrameWidth+CrownGlass_Radius)
                        cylinder { <0,0,-0.024*2*CrownGlass_ScaleZ>,<0,0,0.024*2*CrownGlass_ScaleZ>,CrownGlass_Radius*1.00001
                           translate <CrownGlass_AktPosX,CrownGlass_AktPosY,0>
                        }
                        #declare CrownGlass_AktPosX=CrownGlass_AktPosX+PieceDiameter;
                     #end
                     #declare CrownGlass_AktPosY=CrownGlass_AktPosY+CrownGlass_OffsetY;
                     #declare CrownGlass_LR=-CrownGlass_LR;
                  #end
   
                  texture { CrownGlass_GlassTexture }
                  interior { I_CrownGlass }
               }

               union {
                  #declare CrownGlass_AktPosY=FrameWidth+CrownGlass_Radius;
                  #declare CrownGlass_LR=1;
                  #while (CrownGlass_AktPosY<WindowHeight-FrameWidth+CrownGlass_Radius)
                     #declare CrownGlass_AktPosX=FrameWidth+CrownGlass_Radius;
                     #if (WindowType=2)
                        #declare CrownGlass_AktPosX=FrameWidth+CrownGlass_Radius/2+CrownGlass_LR*CrownGlass_Radius/2;
                     #end
                     #while (CrownGlass_AktPosX<=WindowWidth-FrameWidth+CrownGlass_Radius)
                        object { CrownGlass scale <CrownGlass_Radius,CrownGlass_Radius,CrownGlass_ScaleZ>
                           translate <CrownGlass_AktPosX,CrownGlass_AktPosY,0>
                        }
                        #declare CrownGlass_AktPosX=CrownGlass_AktPosX+PieceDiameter;
                     #end
                     #declare CrownGlass_AktPosY=CrownGlass_AktPosY+CrownGlass_OffsetY;
                     #declare CrownGlass_LR=-CrownGlass_LR;
                  #end
   
               }
            }
         }
      }
   #else
      #debug("Macro CrownGlass_Window_RoundTop: WindowWidth/2 < WindowHeight")
   #end
#end







